#include <stdlib.h>
#include <stdio.h>

#define n_instrucciones 41

char instrucciones[n_instrucciones][7]={"ADDWF","ANDWF","CLRF","CLRW","COMF",
     "DECF","DECFSZ","INCF","INCFSZ","IORWF","MOVF","MOVWF","NOP","RLF","RRF",
     "SUBWF","SWAPF","XORWF","BCF","BSF","BTFSC","BTFSS","ADDLW","ANDLW",
     "CALL","CLRWDT","GOTO","IORLW","MOVLW","RETFIE","RETLW","RETURN","SLEEP",
     "SUBLW","XORLW","EQU","PROTEC","DATA","IF","ELSE","ENDIF"};

char etiquetas[600][7];
int v_etiquetas[600];

unsigned int codigos[n_instrucciones]={1792,1280,384,256,2304,768,2816,2560,
         3840,1024,2048,128,0,3328,3072,512,3584,1536,4096,5120,6144,7168,
         15872,14592,8192,100,10240,14336,12288,9,13312,8,99,15360,14848,
         16384,16385,16386,16387,16388,16389};

char parametros[n_instrucciones][2]={{'f','d'},{'f','d'},{'f','n'},{'n','n'},
       {'f','d'},{'f','d'},{'f','d'},{'f','d'},{'f','d'},{'f','d'},{'f','d'},
       {'f','n'},{'n','n'},{'f','d'},{'f','d'},{'f','d'},{'f','d'},{'f','d'},
       {'f','b'},{'f','b'},{'f','b'},{'f','b'},{'k','n'},{'k','n'},{'k','n'},
       {'n','n'},{'k','n'},{'k','n'},{'k','n'},{'n','n'},{'k','n'},{'n','n'},
       {'n','n'},{'k','n'},{'k','n'},{'k','n'},{'k','n'},{'k','n'},{'d','n'},
       {'n','n'},{'n','n'}};

unsigned int proteccion=0x3FFB;

void asigna_etiquetas(void) {
  int contador;
  unsigned char tempo;

  strcpy(etiquetas[0],"INDF");
  strcpy(etiquetas[1],"TMR0");
  strcpy(etiquetas[2],"PCL");
  strcpy(etiquetas[3],"STATUS");
  strcpy(etiquetas[4],"FSR");
  strcpy(etiquetas[5],"PORTA");
  strcpy(etiquetas[6],"PORTB");
  strcpy(etiquetas[7],"EEDATA");
  strcpy(etiquetas[8],"EEADR");
  strcpy(etiquetas[9],"PCLATH");
  strcpy(etiquetas[10],"INTCON");
  strcpy(etiquetas[11],"OPTION");
  strcpy(etiquetas[12],"TRISA");
  strcpy(etiquetas[13],"TRISB");
  strcpy(etiquetas[14],"EECON1");
  strcpy(etiquetas[15],"EECON2");

  for(contador=0;contador<11;contador++)
    if(contador<7)
      v_etiquetas[contador]=contador;
    else
      v_etiquetas[contador]=contador+1;
  v_etiquetas[11]=1;
  v_etiquetas[12]=5;
  v_etiquetas[13]=6;
  v_etiquetas[14]=8;
  v_etiquetas[15]=9;
}

void mayusculas(char *memoria) {
  int contador=0,contador2=0;
  char stado=0;

  while(memoria[contador]!=0) {
    if((memoria[contador]>='a') && (memoria[contador]<='z')&&(stado==0))
      memoria[contador]=memoria[contador]-32;
    contador2=contador;
    if((memoria[contador]=='\\')&&(stado==1)&&(memoria[contador+1]!=0))
      while(memoria[contador2]!=0) {
	memoria[contador2]=memoria[contador2+1];
	contador2++;
      }
    else {
      if(memoria[contador]=='"')
	stado=1-stado;
      if(memoria[contador]==9)
	memoria[contador]=32;
      if((memoria[contador]==10)||(memoria[contador]==13)||((memoria[contador]==';')&&(stado==0)))
	memoria[contador]=0;
    }
    contador++;
  }
}

void coger(char *memoria,char *parametro,int posicion,int maximo) {
  int p_max,lugar;
  char stado;

  stado=0;
  lugar=0;
  p_max=posicion+maximo;
  while((memoria[posicion]!=0) && (((memoria[posicion]!=' ') && (memoria[posicion]!=',') && (posicion<p_max))||(stado==1))) {
    if(memoria[posicion]=='"')
      stado=1-stado;
    parametro[lugar++]=memoria[posicion++];
  }
  parametro[lugar]=0;
}

int busca(char *instruc) {
  int contador,contador2;
  
  contador2=-1;
  for(contador=0;contador<n_instrucciones;contador++)
    if(0==strcmp(instruc,instrucciones[contador]))
      contador2=contador;
  return(contador2);
}

int busca_p(unsigned char *param) {
  int contador=0,valor=0;
  unsigned char status=0,tempo;

  while(status==0) {
    tempo=param[contador++];
    if((tempo>='0')&&(tempo<='9'))
      valor=10*valor+((int)(tempo-'0'));
    else {
      if(tempo!=0)
	valor=-1;
      status=1;
    }
  }

  if(valor==-1) {
    if((param[0]=='0')&&(param[1]=='X')) {
      status=0;
      contador=2;
      valor=0;
      while((param[contador]!=0)&&(valor>=0)) {
	if((param[contador]>='0')&&(param[contador]<='9'))
	  valor=valor*16+(param[contador]-'0');
	else
	  if((param[contador]>='A')&&(param[contador]<='F'))
	    valor=valor*16+(param[contador]-'A'+10);
	  else
	    valor=-1;
	contador++;
      }
    }
  }

  if(valor==-1) {
    if((param[0]=='"')&&(param[2]=='"'))
      valor=(int)(param[1]);
    else
      valor=-1;
  }

  if(valor==-1) {
    contador=0;
    while((contador<600)&&(valor==-1))
      if(strcmp(etiquetas[contador],param)==0)
	valor=v_etiquetas[contador];
      else
	contador++;
  }

  if(contador==600)
    valor=-2;

  if(param[0]==0)
    valor=-1;

  return(valor);
}

void cracker(char *memoria,char *etiqueta,char *instruccion,char *par1,char *par2) {
  int contador=0,estado=0;
  if(memoria[0]==32) {
    etiqueta[0]=0;
    estado=1;
  } else
    coger(memoria,etiqueta,0,6);
  estado=busca(etiqueta);
  if(estado!=-1) {
    strcpy(instruccion,etiqueta);
    etiqueta[0]=0;
  }
  contador=0;
  if(estado==-1) {
    while((memoria[contador]!=' ') && (memoria[contador]!=0))
      contador++;
    while((memoria[contador]==' ') && (memoria[contador]!=0))
      contador++;		
    coger(memoria,instruccion,contador,6);
  }
  while((memoria[contador]!=' ') && (memoria[contador]!=0))
    contador++;
  while((memoria[contador]==' ') && (memoria[contador]!=0))
    contador++;
  coger(memoria,par1,contador,6);
  while((memoria[contador]!=',') && (memoria[contador]!=0))
    contador++;
  if(memoria[contador]!=0) {
    contador++;
    coger(memoria,par2,contador,6);
  } else
    par2[0]=0;		
}

int test_parm(char *par,char kp,int contador,char salto) {

  int valor;

  if((kp=='n')&&(par[0]!=0)) {
    printf("Too many parameters in line %d\n",contador);
    return(-1);
  }
  if((kp!='n')&&(par[0]==0)) {
    printf("Too less parameters in line %d\n",contador);
    return(-1);
  }
  if(kp!='n')
    valor=busca_p(par);
  else
    valor=0;
  if(valor==-1) {
    printf("Invalid parameter in line %d\n",contador);
    return(-1);
  }
  if(valor==-2) {
    printf("Label not found in line %d\n",contador);
    return(-1);
  }
  if(((kp=='f')&&(valor>127))||((kp=='d')&&(valor>1))||((kp=='b')&&(valor>7))||((salto==0)&&(kp=='k')&&(valor>255))||((salto==1)&&(kp=='k')&&(valor>2047))) {
    printf("Parameter out of range in line %d\n",contador);
    return(-1);
  }
  if((kp=='d')||(kp=='b'))
    valor*=128;
  return(valor);
}

int mete_etiq(char *etiq,int valor) {
  int contador=0,status=1;

  while(status==1) {
    if(strcmp(etiq,etiquetas[contador])==0) {
      status=-1;
    } else
      if(etiquetas[contador][0]==0) {
	strcpy(etiquetas[contador],etiq);
	v_etiquetas[contador]=valor;
	status=0;
      }
    contador++;
    if(contador==600)
      status=-2;
  }
  return(status);
}

int main(int argc,char *argv[]) {
  
  FILE *fichero1,*fichero2;
  unsigned int contador,basura,v_instr,v_par1,v_par2;
  unsigned char memoria[1024],temporal,basura2,cadena[7],salto,salida[100],entrada[100],saca_label;
  char etiqueta[7],instruccion[7],par1[7],par2[7],error,error2,error3,tempo;
  int linea,linea2,l_data,l_code;
  char enif,sigue;

  enif=0;
  sigue=0;
  saca_label=0;
  
  if(argc<2) {
    perror("No input files\n");
    exit(1);
  }
 
  entrada[0]=0;
  salida[0]=0;
  
  for(contador=1;contador<argc;contador++) {
    if(strcmp(argv[contador],"-l")==0)
      saca_label=1;
    else
      if(strcmp(argv[contador],"-o")==0)
	 if(argc>contador+1) {
  	   strcpy(salida,argv[contador+1]);
  	   contador++;
 	 } else {
	   printf("No output file\n");
	   exit(1);
	 }
      else
        strcpy(entrada,argv[contador]);
  }
  
  if(entrada[0]==0) {
    printf("No input file\n");
    exit(1);
  }
  
  if(salida[0]==0)
    strcpy(salida,"out.obj");
  
  fichero1=fopen(entrada,"r");
  if(fichero1==NULL) {
    perror("Can't open input file\n");
    exit(1);
  }

  fichero2=fopen(salida,"w");
  if(fichero1==NULL) {
    perror("Can't open output file\n");
    fclose(fichero1);
    exit(1);
  }

  for(contador=0;contador<600;contador++)
    etiquetas[contador][0]=0;
  asigna_etiquetas();

  contador=1;
  linea=0;
  linea2=0;
  error=0;

  while(!feof(fichero1)) {
    error2=0;
    memoria[0]=0;
    fgets(memoria,1024,fichero1);
    mayusculas(memoria);
    cracker(memoria,etiqueta,instruccion,par1,par2);
    if(busca(instruccion)==39)
      if(enif==0) {
	printf("ELSE without IF in line %d\n",contador);
	error=1;
	error2=1;
      } else
	sigue=1-sigue;

    if(busca(instruccion)==40)
      if(enif==0) {
	printf("ENDIF without IF in line %d\n",contador);
	error=1;
	error2=1;
      } else {
	sigue=0;
	enif=0;
      }
      if((sigue==0)&&(busca(instruccion)==38)) {
	if(enif==1) {
	  printf("Anidated IF in line %d\n",contador);
	  error=1;
	  error2=1;
	} else
	  enif=1;
	v_par1=busca_p(par1);
	if((v_par1==-1)||(v_par1==0))
	  sigue=1;
	else
	  sigue=0;
      }

    if(sigue==0) {

      if(busca(instruccion)==36) {
	v_par1=busca_p(par1);
	if((v_par1==-1)||(v_par1==-2)||(v_par1>0x4000)) {
	  printf("Invalid data for Protec register\n");
	  error=1;
	  error2=1;
	} else
	  proteccion=v_par1;
      }
      if(etiqueta[0]!=0) {
	if((busca(etiqueta)!=-1)||(busca(par1)!=-1)) {
	  printf("Invalid label in line %d\n",contador);
	  error=1;
	  error2=1;
	}
	if(error2==0) {
	  tempo=busca(instruccion);
	  switch(tempo) {
	  case 35:
	    v_par1=busca_p(par1);
	    if((v_par1==-1)||(v_par1==-2)) {
	      printf("Invalid data for EQU in line %d\n",contador);
	      error=1;
	      error2=1;
	    } else
	      basura=v_par1;
	    break;
	  case 36:
	    break;
	  case 37:
	    v_par1=busca_p(par1);
	    if((v_par1==-1)||(v_par1==-2)) {
	      printf("Invalid data for DATA in line %d\n",contador);
	      error=1;
	      error2=1;
	    } else
	      basura=linea2;
	    break;
	  default:
	    basura=linea;
	  }
	}
	if(error2==0)
	  error2=mete_etiq(etiqueta,basura);
	if(error2==-1) {
	  printf("Duplicated label in line %d\n",contador);
	  error=1;
	}
	if(error2==-2) {
	  printf("Too many labels. Sorry\n");
	  error=1;
	}
      }
      if(instruccion[0]!=0)
	if(busca(instruccion)<35)
	  linea++;
	else
	  if(busca(instruccion)==37)
	    linea2++;
    }
    contador++;
  }

  l_code=linea;
  l_data=linea2;

  error3=error;
  rewind(fichero1);
  fprintf(fichero2,"%X\n",proteccion);
  error=0;
  contador=1;
  while(!feof(fichero1)) {
    
    error2=0;
    memoria[0]=0;
    fgets(memoria,1024,fichero1);
    mayusculas(memoria);
    cracker(memoria,etiqueta,instruccion,par1,par2);

    if(busca(instruccion)==39)
      if(enif==1)
	sigue=1-sigue;
    
    if(busca(instruccion)==40)
      if(enif==1) {
	sigue=0;
	enif=0;
      }
    if((sigue==0)&&(busca(instruccion)==38)) {
      if(enif==0)
	enif=1;
      v_par1=busca_p(par1);
      if((v_par1==-1)||(v_par1==0))
	sigue=1;
      else
	sigue=0;
    }

    if(sigue==0) {

      if((instruccion[0]==0)&&(etiqueta[0]!=0)) {
	error=1;
	printf("Missing instruction in line %d\n",contador);
      }
      if(instruccion[0]!=0) {
	v_instr=busca(instruccion);
	if(v_instr==-1) {
	  error=1;
	  error2=1;
	  printf("Invalid instruction in line %d\n",contador);
	} else
	  if(v_instr<35) {
	    if((v_instr==24)||(v_instr==26))
	      salto=1;
	    else
	      salto=0;
	    v_par1=test_parm(par1,parametros[v_instr][0],contador,salto);
	    if(v_par1==-1) {
	      error2=1;
	      error=1;
	    }
	    if(error2==0) {
	      v_par2=test_parm(par2,parametros[v_instr][1],contador,salto);
	      if(v_par2==-1) {
		error=1;
		error2=1;
	      }
	    }
	  }
	if((error2==0)&&(v_instr<35))
	  fprintf(fichero2,"%X\n",codigos[v_instr]+v_par1+v_par2);
      }
    }
    contador++;
  }

  error3+=error;
  rewind(fichero1);
  error=0;
  contador=1;
  fprintf(fichero2,"data:\n");
  while(!feof(fichero1)) {
    
    error2=0;
    memoria[0]=0;
    fgets(memoria,1024,fichero1);
    mayusculas(memoria);
    cracker(memoria,etiqueta,instruccion,par1,par2);

    if(busca(instruccion)==39)
      if(enif==1)
	sigue=1-sigue;
    
    if(busca(instruccion)==40)
      if(enif==1) {
	sigue=0;
	enif=0;
      }
    if((sigue==0)&&(busca(instruccion)==38)) {
      if(enif==0)
	enif=1;
      v_par1=busca_p(par1);
      if((v_par1==-1)||(v_par1==0))
	sigue=1;
      else
	sigue=0;
    }
    
    if(sigue==0) {
      
      if((instruccion[0]==0)&&(etiqueta[0]!=0)) {
	error=1;
      }
      if(instruccion[0]!=0) {
	v_instr=busca(instruccion);
	if(v_instr==-1) {
	  error=1;
	  error2=1;
	} else
	  if(v_instr==37) {
	    v_par1=test_parm(par1,parametros[v_instr][0],contador,0);
	    if(v_par1==-1) {
	      error2=1;
	      error=1;
	    }
	    if(error2==0) {
	      v_par2=test_parm(par2,parametros[v_instr][1],contador,salto);
	      if(v_par2==-1) {
		error=1;
		error2=1;
	      }
	    }
	  }
	if((error2==0)&&(v_instr==37))
	  fprintf(fichero2,"%X\n",v_par1);
      }
    }
    contador++;
  }
  fclose(fichero1);
  fclose(fichero2);
  error3+=error;
  if(error3!=0) {
    strcpy(entrada,"rm ");
    strcat(entrada,salida);
    system(entrada);
  }
  if((saca_label==1)&&(error3==0)) {
    contador=16;
    while (etiquetas[contador][0]!=0) {
      sprintf(memoria,"Label: %s Value: %d",etiquetas[contador],v_etiquetas[contador]);
      while(strlen(memoria)<35)
	strcat(memoria," ");
      printf("%s",memoria);
      if(contador%2==1)
	printf("\n");
      contador++;
    }
    if((contador>16)&&(contador%2==1))
      printf("\n");
  }
  if(error3==0)
    printf("\nCode length: %d bytes. Data length: %d bytes.\n\n",l_code,l_data);
  return(0);
}
