#include <stdlib.h>
#include <stdio.h>

char instrucciones[36][7]={"ADDWF ","ANDWF ","CLRF  ","CLRW  ","COMF  ","DECF  ",
   "DECFSZ","INCF  ","INCFSZ","IORWF ","MOVF  ","MOVWF ","NOP   ","RLF   ",
   "RRF   ","SUBWF ","SWAPF ","XORWF ","BCF   ","BSF   ","BTFSC ","BTFSS ",
   "ADDLW ","ANDLW ","CALL  ","CLRWDT","GOTO  ","IORLW ","MOVLW ","RETFIE",
   "RETLW ","RETURN","SLEEP ","SUBLW ","XORLW ","EQU   "};

int codigos[36]={1792,1280,384,256,2304,768,2816,2560,3840,1024,2048,128,0,3328,3072,
    512,3584,1536,4096,5120,6144,7168,15872,14592,8192,100,10240,14336,12288,9,13312,
    8,99,15360,14848,16384};

char parametros[36][2]={{'f','d'},{'f','d'},{'f','n'},{'n','n'},{'f','d'},{'f','d'},
    {'f','d'},{'f','d'},{'f','d'},{'f','d'},{'f','d'},{'f','n'},{'n','n'},{'f','d'},
    {'f','d'},{'f','d'},{'f','d'},{'f','d'},{'f','b'},{'f','b'},{'f','b'},{'f','b'},
    {'k','n'},{'k','n'},{'k','n'},{'n','n'},{'k','n'},{'k','n'},{'k','n'},{'n','n'},
    {'k','n'},{'n','n'},{'n','n'},{'k','n'},{'k','n'},{'k','n'}};

void print_par(char tipo,int la_linea) {
  int valor;

  if(tipo=='f')
    valor=la_linea&127;
  if(tipo=='d')
    valor=(la_linea&128)/128;
  if(tipo=='b')
    valor=(la_linea&896)/128;
  if(tipo=='k') {
    if((la_linea&12288)==8192)
      valor=la_linea&2047;
    else
      valor=la_linea&255;
  }
  printf("%d",valor);
}


int main(int argc,char *argv[]) {
  
  FILE *fichero1;
  unsigned int contador,contador2,basura;
  char instruccion,memoria[1024],stado;
  int linea,divisor;

  if(argc!=2) {
    perror("Missing input file name.\n");
    exit(1);
  }
  
  fichero1=fopen(argv[1],"r");
  if(fichero1==NULL) {
    perror("Can't open input file.\n");
    exit(1);
  }

  contador=0;
  linea=-1;
  fscanf(fichero1,"%x",&linea);
  if(linea>=0)
    printf("\nProtection data: %x\n\n Addr. Instr. Parameters\n",linea);
  stado=0;

  while(!feof(fichero1)) {
    linea=-1;
    memoria[0]=0;
    fscanf(fichero1,"%s",memoria);
    if(strcmp(memoria,"data:")==0) {
      contador=0;
      stado=1;
      printf("\nEEPROM data:\n Addr  Hex  Dec ASCII\n");
    } else {
      sscanf(memoria,"%X",&linea);
      if(linea>=0)
	if(stado==0) {
	  instruccion=-1;
	  divisor=1;
	  for(contador2=0;contador2<13;contador2++) {
	    for(basura=0;basura<35;basura++) {
	      if((linea&(16383-(divisor-1)))==codigos[basura])
		instruccion=(char)basura;
	      if(instruccion!=-1)
		break;
	    }
	    if(instruccion!=-1)
	      break;
	    else
	      divisor*=2;
	  }
	  printf(" %4d  ",contador);
	  contador++;
	  if(instruccion==-1)
	    printf("Unknown instruction\n");
	  else
	    printf("%s ",instrucciones[instruccion]);
	  if(parametros[instruccion][0]!='n')
	    print_par(parametros[instruccion][0],linea);
	  if(parametros[instruccion][1]!='n') {
	    printf(",");
	    print_par(parametros[instruccion][1],linea);
	  }
	} else {
	  printf(" %3d   %2X  %3d   ",contador,linea,linea);
	  if((linea>31)&&(linea<128))
	    printf("\"%c\"",(char) linea);
	  contador++;
	}
      printf("\n");
    }
  }
  fclose(fichero1);
  return(0);
}
